Index: palm/trunk/SOURCE/radiation_model_mod.f90
===================================================================
--- palm/trunk/SOURCE/radiation_model_mod.f90	(revision 4670)
+++ palm/trunk/SOURCE/radiation_model_mod.f90	(revision 4671)
@@ -10298,21 +10294,22 @@
        SELECT CASE ( TRIM( var ) )
 !--       block of large scale (e.g. RRTMG) radiation output variables
+!--       only upward faced horizontal surfaces are considered here
           CASE ( 'rad_net*' )
              IF ( ALLOCATED( rad_net_av ) ) THEN
                 DO  i = nxl, nxr
                    DO  j = nys, nyn
-                      match_lsm = surf_lsm_h%start_index(j,i) <=               &
-                                  surf_lsm_h%end_index(j,i)
-                      match_usm = surf_usm_h%start_index(j,i) <=               &
-                                  surf_usm_h%end_index(j,i)
+                      match_lsm = surf_lsm_h(0)%start_index(j,i) <=               &
+                                  surf_lsm_h(0)%end_index(j,i)
+                      match_usm = surf_usm_h(0)%start_index(j,i) <=               &
+                                  surf_usm_h(0)%end_index(j,i)
 
                      IF ( match_lsm  .AND.  .NOT. match_usm )  THEN
-                         m = surf_lsm_h%end_index(j,i)
+                         m = surf_lsm_h(0)%end_index(j,i)
                          rad_net_av(j,i) = rad_net_av(j,i) +                   &
-                                         surf_lsm_h%rad_net(m)
+                                         surf_lsm_h(0)%rad_net(m)
                       ELSEIF ( match_usm )  THEN
-                         m = surf_usm_h%end_index(j,i)
+                         m = surf_usm_h(0)%end_index(j,i)
                          rad_net_av(j,i) = rad_net_av(j,i) +                   &
-                                         surf_usm_h%rad_net(m)
+                                         surf_usm_h(0)%rad_net(m)
                       ENDIF
                    ENDDO
@@ -10324,17 +10321,17 @@
                 DO  i = nxl, nxr
                    DO  j = nys, nyn
-                      match_lsm = surf_lsm_h%start_index(j,i) <=               &
-                                  surf_lsm_h%end_index(j,i)
-                      match_usm = surf_usm_h%start_index(j,i) <=               &
-                                  surf_usm_h%end_index(j,i)
+                      match_lsm = surf_lsm_h(0)%start_index(j,i) <=               &
+                                  surf_lsm_h(0)%end_index(j,i)
+                      match_usm = surf_usm_h(0)%start_index(j,i) <=               &
+                                  surf_usm_h(0)%end_index(j,i)
 
                       IF ( match_lsm  .AND.  .NOT. match_usm )  THEN
-                         m = surf_lsm_h%end_index(j,i)
+                         m = surf_lsm_h(0)%end_index(j,i)
                          rad_lw_in_xy_av(j,i) = rad_lw_in_xy_av(j,i) +         &
-                                         surf_lsm_h%rad_lw_in(m)
+                                         surf_lsm_h(0)%rad_lw_in(m)
                       ELSEIF ( match_usm )  THEN
-                         m = surf_usm_h%end_index(j,i)
+                         m = surf_usm_h(0)%end_index(j,i)
                          rad_lw_in_xy_av(j,i) = rad_lw_in_xy_av(j,i) +         &
-                                         surf_usm_h%rad_lw_in(m)
+                                         surf_usm_h(0)%rad_lw_in(m)
                       ENDIF
                    ENDDO
@@ -10346,17 +10343,17 @@
                 DO  i = nxl, nxr
                    DO  j = nys, nyn
-                      match_lsm = surf_lsm_h%start_index(j,i) <=               &
-                                  surf_lsm_h%end_index(j,i)
-                      match_usm = surf_usm_h%start_index(j,i) <=               &
-                                  surf_usm_h%end_index(j,i)
+                      match_lsm = surf_lsm_h(0)%start_index(j,i) <=               &
+                                  surf_lsm_h(0)%end_index(j,i)
+                      match_usm = surf_usm_h(0)%start_index(j,i) <=               &
+                                  surf_usm_h(0)%end_index(j,i)
 
                       IF ( match_lsm  .AND.  .NOT. match_usm )  THEN
-                         m = surf_lsm_h%end_index(j,i)
+                         m = surf_lsm_h(0)%end_index(j,i)
                          rad_lw_out_xy_av(j,i) = rad_lw_out_xy_av(j,i) +       &
-                                                 surf_lsm_h%rad_lw_out(m)
+                                                 surf_lsm_h(0)%rad_lw_out(m)
                       ELSEIF ( match_usm )  THEN
-                         m = surf_usm_h%end_index(j,i)
+                         m = surf_usm_h(0)%end_index(j,i)
                          rad_lw_out_xy_av(j,i) = rad_lw_out_xy_av(j,i) +       &
-                                                 surf_usm_h%rad_lw_out(m)
+                                                 surf_usm_h(0)%rad_lw_out(m)
                       ENDIF
                    ENDDO
@@ -10368,17 +10365,17 @@
                 DO  i = nxl, nxr
                    DO  j = nys, nyn
-                      match_lsm = surf_lsm_h%start_index(j,i) <=               &
-                                  surf_lsm_h%end_index(j,i)
-                      match_usm = surf_usm_h%start_index(j,i) <=               &
-                                  surf_usm_h%end_index(j,i)
+                      match_lsm = surf_lsm_h(0)%start_index(j,i) <=               &
+                                  surf_lsm_h(0)%end_index(j,i)
+                      match_usm = surf_usm_h(0)%start_index(j,i) <=               &
+                                  surf_usm_h(0)%end_index(j,i)
 
                       IF ( match_lsm  .AND.  .NOT. match_usm )  THEN
-                         m = surf_lsm_h%end_index(j,i)
+                         m = surf_lsm_h(0)%end_index(j,i)
                          rad_sw_in_xy_av(j,i) = rad_sw_in_xy_av(j,i) +         &
-                                                surf_lsm_h%rad_sw_in(m)
+                                                surf_lsm_h(0)%rad_sw_in(m)
                       ELSEIF ( match_usm )  THEN
-                         m = surf_usm_h%end_index(j,i)
+                         m = surf_usm_h(0)%end_index(j,i)
                          rad_sw_in_xy_av(j,i) = rad_sw_in_xy_av(j,i) +         &
-                                                surf_usm_h%rad_sw_in(m)
+                                                surf_usm_h(0)%rad_sw_in(m)
                       ENDIF
                    ENDDO
@@ -10390,17 +10387,17 @@
                 DO  i = nxl, nxr
                    DO  j = nys, nyn
-                      match_lsm = surf_lsm_h%start_index(j,i) <=               &
-                                  surf_lsm_h%end_index(j,i)
-                      match_usm = surf_usm_h%start_index(j,i) <=               &
-                                  surf_usm_h%end_index(j,i)
+                      match_lsm = surf_lsm_h(0)%start_index(j,i) <=               &
+                                  surf_lsm_h(0)%end_index(j,i)
+                      match_usm = surf_usm_h(0)%start_index(j,i) <=               &
+                                  surf_usm_h(0)%end_index(j,i)
 
                       IF ( match_lsm  .AND.  .NOT. match_usm )  THEN
-                         m = surf_lsm_h%end_index(j,i)
+                         m = surf_lsm_h(0)%end_index(j,i)
                          rad_sw_out_xy_av(j,i) = rad_sw_out_xy_av(j,i) +       &
-                                                 surf_lsm_h%rad_sw_out(m)
+                                                 surf_lsm_h(0)%rad_sw_out(m)
                       ELSEIF ( match_usm )  THEN
-                         m = surf_usm_h%end_index(j,i)
+                         m = surf_usm_h(0)%end_index(j,i)
                          rad_sw_out_xy_av(j,i) = rad_sw_out_xy_av(j,i) +       &
-                                                 surf_usm_h%rad_sw_out(m)
+                                                 surf_usm_h(0)%rad_sw_out(m)
                       ENDIF
                    ENDDO
@@ -11072,14 +11069,15 @@
 !
 !--                Obtain rad_net from its respective surface type
+!--                Only upward faced horizontal outputs are considered here
 !--                Natural-type surfaces
-                   DO  m = surf_lsm_h%start_index(j,i),                        &
-                           surf_lsm_h%end_index(j,i)
-                      local_pf(i,j,nzb+1) = surf_lsm_h%rad_net(m)
+                   DO  m = surf_lsm_h(0)%start_index(j,i),                        &
+                           surf_lsm_h(0)%end_index(j,i)
+                      local_pf(i,j,nzb+1) = surf_lsm_h(0)%rad_net(m)
                    ENDDO
 !
 !--                Urban-type surfaces
-                   DO  m = surf_usm_h%start_index(j,i),                        &
-                           surf_usm_h%end_index(j,i)
-                      local_pf(i,j,nzb+1) = surf_usm_h%rad_net(m)
+                   DO  m = surf_usm_h(0)%start_index(j,i),                        &
+                           surf_usm_h(0)%end_index(j,i)
+                      local_pf(i,j,nzb+1) = surf_usm_h(0)%rad_net(m)
                    ENDDO
                 ENDDO
@@ -11106,13 +11104,13 @@
 !--                Obtain rad_net from its respective surface type
 !--                Natural-type surfaces
-                   DO  m = surf_lsm_h%start_index(j,i),                        &
-                           surf_lsm_h%end_index(j,i)
-                      local_pf(i,j,nzb+1) = surf_lsm_h%rad_lw_in(m)
+                   DO  m = surf_lsm_h(0)%start_index(j,i),                        &
+                           surf_lsm_h(0)%end_index(j,i)
+                      local_pf(i,j,nzb+1) = surf_lsm_h(0)%rad_lw_in(m)
                    ENDDO
 !
 !--                Urban-type surfaces
-                   DO  m = surf_usm_h%start_index(j,i),                        &
-                           surf_usm_h%end_index(j,i)
-                      local_pf(i,j,nzb+1) = surf_usm_h%rad_lw_in(m)
+                   DO  m = surf_usm_h(0)%start_index(j,i),                        &
+                           surf_usm_h(0)%end_index(j,i)
+                      local_pf(i,j,nzb+1) = surf_usm_h(0)%rad_lw_in(m)
                    ENDDO
                 ENDDO
@@ -11139,13 +11137,13 @@
 !--                Obtain rad_net from its respective surface type
 !--                Natural-type surfaces
-                   DO  m = surf_lsm_h%start_index(j,i),                        &
-                           surf_lsm_h%end_index(j,i)
-                      local_pf(i,j,nzb+1) = surf_lsm_h%rad_lw_out(m)
+                   DO  m = surf_lsm_h(0)%start_index(j,i),                        &
+                           surf_lsm_h(0)%end_index(j,i)
+                      local_pf(i,j,nzb+1) = surf_lsm_h(0)%rad_lw_out(m)
                    ENDDO
 !
 !--                Urban-type surfaces
-                   DO  m = surf_usm_h%start_index(j,i),                        &
-                           surf_usm_h%end_index(j,i)
-                      local_pf(i,j,nzb+1) = surf_usm_h%rad_lw_out(m)
+                   DO  m = surf_usm_h(0)%start_index(j,i),                        &
+                           surf_usm_h(0)%end_index(j,i)
+                      local_pf(i,j,nzb+1) = surf_usm_h(0)%rad_lw_out(m)
                    ENDDO
                 ENDDO
@@ -11172,13 +11170,13 @@
 !--                Obtain rad_net from its respective surface type
 !--                Natural-type surfaces
-                   DO  m = surf_lsm_h%start_index(j,i),                        &
-                           surf_lsm_h%end_index(j,i)
-                      local_pf(i,j,nzb+1) = surf_lsm_h%rad_sw_in(m)
+                   DO  m = surf_lsm_h(0)%start_index(j,i),                        &
+                           surf_lsm_h(0)%end_index(j,i)
+                      local_pf(i,j,nzb+1) = surf_lsm_h(0)%rad_sw_in(m)
                    ENDDO
 !
 !--                Urban-type surfaces
-                   DO  m = surf_usm_h%start_index(j,i),                        &
-                           surf_usm_h%end_index(j,i)
-                      local_pf(i,j,nzb+1) = surf_usm_h%rad_sw_in(m)
+                   DO  m = surf_usm_h(0)%start_index(j,i),                        &
+                           surf_usm_h(0)%end_index(j,i)
+                      local_pf(i,j,nzb+1) = surf_usm_h(0)%rad_sw_in(m)
                    ENDDO
                 ENDDO
@@ -11205,13 +11203,13 @@
 !--                Obtain rad_net from its respective surface type
 !--                Natural-type surfaces
-                   DO  m = surf_lsm_h%start_index(j,i),                        &
-                           surf_lsm_h%end_index(j,i)
-                      local_pf(i,j,nzb+1) = surf_lsm_h%rad_sw_out(m)
+                   DO  m = surf_lsm_h(0)%start_index(j,i),                        &
+                           surf_lsm_h(0)%end_index(j,i)
+                      local_pf(i,j,nzb+1) = surf_lsm_h(0)%rad_sw_out(m)
                    ENDDO
 !
 !--                Urban-type surfaces
-                   DO  m = surf_usm_h%start_index(j,i),                        &
-                           surf_usm_h%end_index(j,i)
-                      local_pf(i,j,nzb+1) = surf_usm_h%rad_sw_out(m)
+                   DO  m = surf_usm_h(0)%start_index(j,i),                        &
+                           surf_usm_h(0)%end_index(j,i)
+                      local_pf(i,j,nzb+1) = surf_usm_h(0)%rad_sw_out(m)
                    ENDDO
                 ENDDO
Index: palm/trunk/SOURCE/read_restart_data_mod.f90
===================================================================
--- palm/trunk/SOURCE/read_restart_data_mod.f90	(revision 4670)
+++ palm/trunk/SOURCE/read_restart_data_mod.f90	(revision 4671)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Implementation of downward facing USM and LSM surfaces
+!
+! 4617 2020-07-22 09:48:50Z raasch
 ! check, if boundary conditions in the prerun are both set to cyclic
 !
@@ -269,5 +272,5 @@
        READ ( 13 )  version_on_file
 
-       binary_version_global = '5.0'
+       binary_version_global = '5.1'
        IF ( TRIM( version_on_file ) /= TRIM( binary_version_global ) )  THEN
           WRITE( message_string, * ) 'version mismatch concerning ',           &
@@ -867,5 +870,5 @@
        CALL rrd_mpi_io( 'binary_version_global',  version_on_file )
 
-       binary_version_global = '5.0'
+       binary_version_global = '5.1'
        IF ( TRIM( version_on_file ) /= TRIM( binary_version_global ) )  THEN
           WRITE( message_string, * ) 'version mismatch concerning binary_version_global:',         &
@@ -1700,5 +1703,5 @@
           READ ( 13 )  version_on_file
 
-          binary_version_local = '5.0'
+          binary_version_local = '5.1'
           IF ( TRIM( version_on_file ) /= TRIM( binary_version_local ) )  THEN
              WRITE( message_string, * ) 'version mismatch concerning ',                               &
Index: palm/trunk/SOURCE/salsa_mod.f90
===================================================================
--- palm/trunk/SOURCE/salsa_mod.f90	(revision 4670)
+++ palm/trunk/SOURCE/salsa_mod.f90	(revision 4671)
@@ -21,9 +21,12 @@
 ! Current revisions:
 ! -----------------
-! 
-! 
+!
+!
 ! Former revisions:
 ! -----------------
 ! $Id$
+! Implementation of downward facing USM and LSM surfaces
+! 
+! 4535 2020-05-15 12:07:23Z raasch
 ! bugfix for restart data format query
 ! 
@@ -850,6 +853,6 @@
     TYPE(t_section), DIMENSION(:), ALLOCATABLE ::  aero  !< local aerosol properties
 
-    TYPE(match_surface) ::  lsm_to_depo_h  !< to match the deposition module and horizontal LSM surfaces
-    TYPE(match_surface) ::  usm_to_depo_h  !< to match the deposition module and horizontal USM surfaces
+    TYPE(match_surface), DIMENSION(0:1) ::  lsm_to_depo_h  !< to match the deposition module and horizontal LSM surfaces
+    TYPE(match_surface), DIMENSION(0:1) ::  usm_to_depo_h  !< to match the deposition module and horizontal USM surfaces
 
     TYPE(match_surface), DIMENSION(0:3) ::  lsm_to_depo_v  !< to match the deposition mod. and vertical LSM surfaces
@@ -1695,16 +1698,16 @@
     ENDDO
 !
-!-- Horizontal surfaces: natural type
-    ALLOCATE( surf_lsm_h%answs( 1:surf_lsm_h%ns, nbins_aerosol ) )
-    ALLOCATE( surf_lsm_h%amsws( 1:surf_lsm_h%ns, nbins_aerosol*ncomponents_mass ) )
-    surf_lsm_h%answs = 0.0_wp
-    surf_lsm_h%amsws = 0.0_wp
-!
-!-- Horizontal surfaces: urban type
-    ALLOCATE( surf_usm_h%answs( 1:surf_usm_h%ns, nbins_aerosol ) )
-    ALLOCATE( surf_usm_h%amsws( 1:surf_usm_h%ns, nbins_aerosol*ncomponents_mass ) )
-    surf_usm_h%answs = 0.0_wp
-    surf_usm_h%amsws = 0.0_wp
-
+!-- Horizontal surfaces: natural and urban type
+    DO l = 0, 1
+       ALLOCATE( surf_lsm_h(l)%answs( 1:surf_lsm_h(l)%ns, nbins_aerosol ) )
+       ALLOCATE( surf_lsm_h(l)%amsws( 1:surf_lsm_h(l)%ns, nbins_aerosol*ncomponents_mass ) )
+       surf_lsm_h(l)%answs = 0.0_wp
+       surf_lsm_h(l)%amsws = 0.0_wp
+
+       ALLOCATE( surf_usm_h(l)%answs( 1:surf_usm_h(l)%ns, nbins_aerosol ) )
+       ALLOCATE( surf_usm_h(l)%amsws( 1:surf_usm_h(l)%ns, nbins_aerosol*ncomponents_mass ) )
+       surf_usm_h(l)%answs = 0.0_wp
+       surf_usm_h(l)%amsws = 0.0_wp
+    ENDDO
 !
 !-- Vertical surfaces: northward (l=0), southward (l=1), eastward (l=2) and westward (l=3) facing
@@ -1797,10 +1800,11 @@
           surf_def_h(l)%gtsws = 0.0_wp
        ENDDO
-!--    Horizontal surfaces: natural type
-       ALLOCATE( surf_lsm_h%gtsws( 1:surf_lsm_h%ns, ngases_salsa ) )
-       surf_lsm_h%gtsws = 0.0_wp
-!--    Horizontal surfaces: urban type
-       ALLOCATE( surf_usm_h%gtsws( 1:surf_usm_h%ns, ngases_salsa ) )
-       surf_usm_h%gtsws = 0.0_wp
+!--    Horizontal surfaces: natural and urban type
+       DO l = 0, 1
+          ALLOCATE( surf_lsm_h(l)%gtsws( 1:surf_lsm_h(l)%ns, ngases_salsa ) )
+          surf_lsm_h(l)%gtsws = 0.0_wp
+          ALLOCATE( surf_usm_h(l)%gtsws( 1:surf_usm_h(l)%ns, ngases_salsa ) )
+          surf_usm_h(l)%gtsws = 0.0_wp
+       ENDDO
 !
 !--    Vertical surfaces: northward (l=0), southward (l=1), eastward (l=2) and 
@@ -2747,12 +2751,14 @@
     IF ( nldepo_surf  .AND.  land_surface )  THEN
        match_lsm = .TRUE.
-       ALLOCATE( lsm_to_depo_h%match_lupg(1:surf_lsm_h%ns),                                         &
-                 lsm_to_depo_h%match_luvw(1:surf_lsm_h%ns),                                         &
-                 lsm_to_depo_h%match_luww(1:surf_lsm_h%ns) )
-       lsm_to_depo_h%match_lupg = 0
-       lsm_to_depo_h%match_luvw = 0
-       lsm_to_depo_h%match_luww = 0
-       CALL match_sm_zhang( surf_lsm_h, lsm_to_depo_h%match_lupg, lsm_to_depo_h%match_luvw,        &
-                            lsm_to_depo_h%match_luww, match_lsm )
+       DO l = 0, 1
+          ALLOCATE( lsm_to_depo_h(l)%match_lupg(1:surf_lsm_h(l)%ns),                               &
+                    lsm_to_depo_h(l)%match_luvw(1:surf_lsm_h(l)%ns),                               &
+                    lsm_to_depo_h(l)%match_luww(1:surf_lsm_h(l)%ns) )
+          lsm_to_depo_h(l)%match_lupg = 0
+          lsm_to_depo_h(l)%match_luvw = 0
+          lsm_to_depo_h(l)%match_luww = 0
+          CALL match_sm_zhang( surf_lsm_h(l), lsm_to_depo_h(l)%match_lupg,                         &
+                               lsm_to_depo_h(l)%match_luvw, lsm_to_depo_h(l)%match_luww, match_lsm )
+       ENDDO
        DO  l = 0, 3
           ALLOCATE( lsm_to_depo_v(l)%match_lupg(1:surf_lsm_v(l)%ns),                               &
@@ -2770,12 +2776,14 @@
     IF ( nldepo_surf  .AND.  urban_surface )  THEN
        match_lsm = .FALSE.
-       ALLOCATE( usm_to_depo_h%match_lupg(1:surf_usm_h%ns),                                        &
-                 usm_to_depo_h%match_luvw(1:surf_usm_h%ns),                                        &
-                 usm_to_depo_h%match_luww(1:surf_usm_h%ns) )
-       usm_to_depo_h%match_lupg = 0
-       usm_to_depo_h%match_luvw = 0
-       usm_to_depo_h%match_luww = 0
-       CALL match_sm_zhang( surf_usm_h, usm_to_depo_h%match_lupg, usm_to_depo_h%match_luvw,        &
-                            usm_to_depo_h%match_luww, match_lsm )
+       DO l = 0, 1
+          ALLOCATE( usm_to_depo_h(l)%match_lupg(1:surf_usm_h(l)%ns),                               &
+                    usm_to_depo_h(l)%match_luvw(1:surf_usm_h(l)%ns),                               &
+                    usm_to_depo_h(l)%match_luww(1:surf_usm_h(l)%ns) )
+          usm_to_depo_h(l)%match_lupg = 0
+          usm_to_depo_h(l)%match_luvw = 0
+          usm_to_depo_h(l)%match_luww = 0
+          CALL match_sm_zhang( surf_usm_h(l), usm_to_depo_h(l)%match_lupg,                         &
+                               usm_to_depo_h(l)%match_luvw, usm_to_depo_h(l)%match_luww, match_lsm )
+       ENDDO
        DO  l = 0, 3
           ALLOCATE( usm_to_depo_v(l)%match_lupg(1:surf_usm_v(l)%ns),                               &
@@ -4099,13 +4107,15 @@
           ENDDO
        ELSE
-          CALL depo_surf( i, j, surf_usm_h, vd, schmidt_num, kvis, in_u, .TRUE., usm_to_depo_h )
+          DO  l = 0, 1
+             CALL depo_surf( i, j, surf_usm_h(l), vd, schmidt_num, kvis, in_u, .TRUE., usm_to_depo_h(l) )
+          ENDDO
           DO  l = 0, 3
-             CALL depo_surf( i, j, surf_usm_v(l), vd, schmidt_num, kvis, in_u, .FALSE.,            &
-                             usm_to_depo_v(l) )
+             CALL depo_surf( i, j, surf_usm_v(l), vd, schmidt_num, kvis, in_u, .FALSE., usm_to_depo_v(l) )
           ENDDO
-          CALL depo_surf( i, j, surf_lsm_h, vd, schmidt_num, kvis, in_u, .TRUE., lsm_to_depo_h )
+          DO  l = 0, 1
+             CALL depo_surf( i, j, surf_lsm_h(l), vd, schmidt_num, kvis, in_u, .TRUE., lsm_to_depo_h(l) )
+          ENDDO
           DO  l = 0, 3
-             CALL depo_surf( i, j, surf_lsm_v(l), vd, schmidt_num, kvis, in_u, .FALSE.,            &
-                             lsm_to_depo_v(l) )
+             CALL depo_surf( i, j, surf_lsm_v(l), vd, schmidt_num, kvis, in_u, .FALSE., lsm_to_depo_v(l) )
           ENDDO
        ENDIF
@@ -8568,5 +8578,6 @@
           CALL diffusion_s( i, j, rs, surf_def_h(0)%answs(:,ib),                                   &
                                       surf_def_h(1)%answs(:,ib), surf_def_h(2)%answs(:,ib),        &
-                                      surf_lsm_h%answs(:,ib),    surf_usm_h%answs(:,ib),           &
+                                      surf_lsm_h(0)%answs(:,ib), surf_lsm_h(1)%answs(:,ib),        &
+                                      surf_usm_h(0)%answs(:,ib), surf_usm_h(1)%answs(:,ib),        &
                                       surf_def_v(0)%answs(:,ib), surf_def_v(1)%answs(:,ib),        &
                                       surf_def_v(2)%answs(:,ib), surf_def_v(3)%answs(:,ib),        &
@@ -8578,5 +8589,6 @@
           CALL diffusion_s( i, j, rs, surf_def_h(0)%amsws(:,icc),                                  &
                                       surf_def_h(1)%amsws(:,icc), surf_def_h(2)%amsws(:,icc),      &
-                                      surf_lsm_h%amsws(:,icc),    surf_usm_h%amsws(:,icc),         &
+                                      surf_lsm_h(0)%amsws(:,icc), surf_lsm_h(1)%amsws(:,icc),      &
+                                      surf_usm_h(0)%amsws(:,icc), surf_usm_h(1)%amsws(:,icc),      &
                                       surf_def_v(0)%amsws(:,icc), surf_def_v(1)%amsws(:,icc),      &
                                       surf_def_v(2)%amsws(:,icc), surf_def_v(3)%amsws(:,icc),      &
@@ -8588,5 +8600,6 @@
           CALL diffusion_s( i, j, rs, surf_def_h(0)%gtsws(:,ib),                                   &
                                       surf_def_h(1)%gtsws(:,ib), surf_def_h(2)%gtsws(:,ib),        &
-                                      surf_lsm_h%gtsws(:,ib), surf_usm_h%gtsws(:,ib),              &
+                                      surf_lsm_h(0)%gtsws(:,ib), surf_lsm_h(1)%gtsws(:,ib),        &
+                                      surf_usm_h(0)%gtsws(:,ib), surf_usm_h(1)%gtsws(:,ib),        &
                                       surf_def_v(0)%gtsws(:,ib), surf_def_v(1)%gtsws(:,ib),        &
                                       surf_def_v(2)%gtsws(:,ib), surf_def_v(3)%gtsws(:,ib),        &
@@ -8703,5 +8716,6 @@
           CALL diffusion_s( rs, surf_def_h(0)%answs(:,ib),                                         &
                                 surf_def_h(1)%answs(:,ib), surf_def_h(2)%answs(:,ib),              &
-                                surf_lsm_h%answs(:,ib),    surf_usm_h%answs(:,ib),                 &
+                                surf_lsm_h(0)%answs(:,ib), surf_lsm_h(1)%answs(:,ib),              &
+                                surf_usm_h(0)%answs(:,ib), surf_usm_h(1)%answs(:,ib),              &
                                 surf_def_v(0)%answs(:,ib), surf_def_v(1)%answs(:,ib),              &
                                 surf_def_v(2)%answs(:,ib), surf_def_v(3)%answs(:,ib),              &
@@ -8713,5 +8727,6 @@
           CALL diffusion_s( rs, surf_def_h(0)%amsws(:,icc),                                        &
                                 surf_def_h(1)%amsws(:,icc), surf_def_h(2)%amsws(:,icc),            &
-                                surf_lsm_h%amsws(:,icc),    surf_usm_h%amsws(:,icc),               &
+                                surf_lsm_h(0)%amsws(:,icc), surf_lsm_h(1)%amsws(:,icc),            &
+                                surf_usm_h(0)%amsws(:,icc), surf_usm_h(1)%amsws(:,icc),            &
                                 surf_def_v(0)%amsws(:,icc), surf_def_v(1)%amsws(:,icc),            &
                                 surf_def_v(2)%amsws(:,icc), surf_def_v(3)%amsws(:,icc),            &
@@ -8723,5 +8738,6 @@
           CALL diffusion_s( rs, surf_def_h(0)%gtsws(:,ib),                                         &
                                 surf_def_h(1)%gtsws(:,ib), surf_def_h(2)%gtsws(:,ib),              &
-                                surf_lsm_h%gtsws(:,ib),    surf_usm_h%gtsws(:,ib),                 &
+                                surf_lsm_h(0)%gtsws(:,ib), surf_lsm_h(1)%gtsws(:,ib),              &
+                                surf_usm_h(0)%gtsws(:,ib), surf_usm_h(1)%gtsws(:,ib),              &
                                 surf_def_v(0)%gtsws(:,ib), surf_def_v(1)%gtsws(:,ib),              &
                                 surf_def_v(2)%gtsws(:,ib), surf_def_v(3)%gtsws(:,ib),              &
@@ -9641,5 +9657,5 @@
 !
 !--             Set fluxes normalised based on the street type on land surfaces
-                CALL set_flux( surf_lsm_h, cc_i2m, aerosol_flux_mass_fracs_a, source_array )
+                CALL set_flux( surf_lsm_h(0), cc_i2m, aerosol_flux_mass_fracs_a, source_array )
              ENDIF
 
@@ -9652,8 +9668,8 @@
           surf_def_h(0)%answs = 0.0_wp
           surf_def_h(0)%amsws = 0.0_wp
-          surf_lsm_h%answs = 0.0_wp
-          surf_lsm_h%amsws = 0.0_wp
-          surf_usm_h%answs = 0.0_wp
-          surf_usm_h%amsws = 0.0_wp
+          surf_lsm_h(0)%answs = 0.0_wp
+          surf_lsm_h(0)%amsws = 0.0_wp
+          surf_usm_h(0)%answs = 0.0_wp
+          surf_usm_h(0)%amsws = 0.0_wp
 
 !
@@ -10025,7 +10041,7 @@
                                   aero_emission%mass_fracs(in,:), source_array )
                 ELSE
-                   CALL set_flux( surf_usm_h, aero_emission_att%cc_in2mod,                         &
+                   CALL set_flux( surf_usm_h(0), aero_emission_att%cc_in2mod,                      &
                                   aero_emission%mass_fracs(in,:), source_array )
-                   CALL set_flux( surf_lsm_h, aero_emission_att%cc_in2mod,                         &
+                   CALL set_flux( surf_lsm_h(0), aero_emission_att%cc_in2mod,                      &
                                   aero_emission%mass_fracs(in,:), source_array )
                 ENDIF
@@ -10068,7 +10084,7 @@
                                   aero_emission%mass_fracs(in,:), source_array )
                 ELSE
-                   CALL set_flux( surf_usm_h, aero_emission_att%cc_in2mod,                         &
+                   CALL set_flux( surf_usm_h(0), aero_emission_att%cc_in2mod,                      &
                                   aero_emission%mass_fracs(in,:), source_array )
-                   CALL set_flux( surf_lsm_h, aero_emission_att%cc_in2mod,                         &
+                   CALL set_flux( surf_lsm_h(0), aero_emission_att%cc_in2mod,                      &
                                   aero_emission%mass_fracs(in,:), source_array )
                 ENDIF
@@ -10340,6 +10356,6 @@
 !-- Reset surface fluxes
     surf_def_h(0)%gtsws = 0.0_wp
-    surf_lsm_h%gtsws = 0.0_wp
-    surf_usm_h%gtsws = 0.0_wp
+    surf_lsm_h(0)%gtsws = 0.0_wp
+    surf_usm_h(0)%gtsws = 0.0_wp
 
 #if defined( __netcdf )
@@ -10534,7 +10550,7 @@
                                 dum_var_3d, time_factor(in) )
           ELSE
-             CALL set_gas_flux( surf_usm_h, emission_index_chem, chem_emission_att%units,       &
+             CALL set_gas_flux( surf_usm_h(0), emission_index_chem, chem_emission_att%units,    &
                                 dum_var_3d, time_factor(in) )
-             CALL set_gas_flux( surf_lsm_h, emission_index_chem, chem_emission_att%units,       &
+             CALL set_gas_flux( surf_lsm_h(0), emission_index_chem, chem_emission_att%units,    &
                                 dum_var_3d, time_factor(in) )
           ENDIF
@@ -10565,7 +10581,7 @@
                              dum_var_5d(1,1,:,:,:) )
        ELSE
-          CALL set_gas_flux( surf_usm_h, emission_index_chem, chem_emission_att%units,             &
+          CALL set_gas_flux( surf_usm_h(0), emission_index_chem, chem_emission_att%units,          &
                              dum_var_5d(1,1,:,:,:) )
-          CALL set_gas_flux( surf_lsm_h, emission_index_chem, chem_emission_att%units,             &
+          CALL set_gas_flux( surf_lsm_h(0), emission_index_chem, chem_emission_att%units,          &
                              dum_var_5d(1,1,:,:,:) )
        ENDIF
